/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	メール使用可能チェッククラス
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.xmo.util;

import java.util.*;
import jp.co.ntt.lms.xmo.*;
import jp.co.ntt.lms.xmo.Base.*;
import jp.co.ntt.lms.xmo.RoleAssignments.RoleAssignmentsClient;

/**
 * メール使用可能チェッククラス<BR>
 * XMSⅡでメール機能が使用可能かチェックするクラスです。
 * @author T.Nijou
 * @version 0.0.0.1
 */
public class MailUsable {

	private static final String MAIL_ClASS_NAME = "jp.co.ntt.lms.xmo.Mail.Mail";
	
	private static final String MAIL_XMO_ID = "11";

	/**
	 * メール機能が使用可能かどうかチェックします。
	 * @return boolean true: 使用可能 false: 使用不可
	 * @param strUserId ユーザID
	 * @param strTargetId 権限が及ぶ対象ID
	 * @exception XMOException XMOEntry検索で失敗した場合
	 * @exception Exception RMI通信で失敗した場合
	 */
	public static boolean isUsable(String strUserId, String strTargetId)
		throws XMOException, Exception
	{
		boolean boolStatus = false;
		boolean boolRet = false;
		
		// XMS_Bクライアントのインスタンス化
		XMSBaseClient objXMSBase = new XMSBaseClient();
		// 検索を実行します
		if( !objXMSBase.select() ) {
			throw new XMOException( objXMSBase.getMessageData() );
		}

		// 検索結果の取得
		while( objXMSBase.next() ) {
			String strClassName = objXMSBase.getClassName();
			if( MAIL_ClASS_NAME.equals( strClassName ) ) {
				boolStatus = true;
			}
		}
		// メール機能が備わっていた場合、XMOIDリストを取得
		if(boolStatus){
			RoleAssignmentsClient objRoleAss = new RoleAssignmentsClient();
			
			if(!objRoleAss.searchXmoList(strUserId, strTargetId)){
				throw new XMOException( objRoleAss.getMessageData() );
			}
			
			String[] strXmoList = objRoleAss.getXmoList();
			for( int i = 0; i < strXmoList.length; i++ ) {
				if(strXmoList[i].equals(MAIL_XMO_ID)){
					boolRet = true;
				}
			}
		}

		return boolRet;
	}
}


